import java.awt.Point;
import java.util.Arrays;
import java.util.Random;

public class Haupt {
    public static int punktAnz = 35;
    
    // erzeugt ein Array von anz Point-Objekten
    public static MyPoint[] generatePointArray(int anz) {
        Random rg = new Random(20);  // 20 ist hier der seed für den zufallsgenerator
        MyPoint[] pa = new MyPoint[anz];
        for(int i = 0; i < anz; i++) {
            int px = (int) (rg.nextDouble() * 30) - 15; // Zahlen zw. -15 und 15
            int py = (int) (rg.nextDouble() * 30) - 15;
            pa[i] = new MyPoint(px,py);
        }
        return pa;
    }

    public static double gesamtstrecke(MyPoint[] sas) {
        double gesamtstrecke = 0;
        gesamtstrecke = gesamtstrecke + sas[0].distance(0,0);
        for(int i = 0; i < (sas.length - 1); i ++) {
            gesamtstrecke = gesamtstrecke + sas[i+1].distance(sas[i]);
        }
        return gesamtstrecke;
    }

    public static void main(String[] args) {
        MyPoint[] pointArray = generatePointArray(punktAnz);

        Arrays.sort(pointArray);
        for (int j = 0; j < (pointArray.length-1) ; j++){
            /*
             * positioniert denjenigen Punkt an Index j+1, 
             * der den geringsten Abstand vom Punkt am Index j hat
             */
            double mommin = pointArray[j].distance(pointArray[j+1]);
            int idxmin = j+1;
            for (int i = j+1; i < pointArray.length ; i++) {
                double d = pointArray[j].distance(pointArray[i]);
                if(d < mommin) {
                    mommin = d;
                    idxmin = i;
                }
            }
            MyPoint hv = pointArray[j+1];
            pointArray[j+1] = pointArray[idxmin];
            pointArray[idxmin] = hv;
            //----------------------------------------
        }

        for(int i = 0 ;  i < pointArray.length; i++) {
            System.out.println("Punkt: "+pointArray[i] +
                " hat den Abstand "+pointArray[i].distance(0,0)+
                " vom Ursprung");
        }

        System.out.println("gesamt: "+ gesamtstrecke(pointArray));

        // Optimierung der Tour:
        // Es werden tausend Mal zwei zufällige Streckenpunkte vertauscht.
        // Falls eine Vertauschung die Strecke verkürzt, haben wir eine
        // neue, bessere Tour gefunden. Mit dieser verbesserten
        // Tour wird weitergemacht.
        double guteTourlaenge = gesamtstrecke(pointArray);
        double neueTourlaenge = 0;
        for( int e = 0 ; e < 1000 ; e++) {
            MyPoint[] testArray = pointArray.clone();
            tauscheZweiPunkte(testArray);
            neueTourlaenge = gesamtstrecke(testArray);
            if(neueTourlaenge < guteTourlaenge) {
                pointArray = testArray;
                guteTourlaenge = neueTourlaenge;
                System.out.println("Bessere Lösung mit Länge: "+guteTourlaenge);
            }
        }

        PointGUI pg = new PointGUI();
        pg.pointArray = pointArray;
        pg.zeigeFenster();

    }

    
    public static void tauscheZweiPunkte(MyPoint[] dad) {
        Random jd = new Random(); // Zufallszahlengenerator

        // zwei indexe aus dem MyPoint-Array zufällig finden
        int j = (int) (jd.nextDouble() * punktAnz); 
        int b = (int) (jd.nextDouble() * punktAnz);
        
        // Vertauschung dieser zwei Indexe
        MyPoint hv = dad[j];
        dad[j] = dad[b];
        dad[b] = hv;

    }

}

